diff --git a/src/elflint.c b/src/elflint.c
index c1f0be5..f3c325a 100644
--- a/src/elflint.c
+++ b/src/elflint.c
@@ -45,6 +45,7 @@
 #include "../libdw/libdwP.h"
 #include "../libdwfl/libdwflP.h"
 #include "../libdw/memory-access.h"
+#include "nested_func.h"
 
 
 /* Name and version of program.  */
@@ -3387,7 +3388,7 @@ check_attributes (Ebl *ebl, GElf_Ehdr *ehdr, GElf_Shdr *shdr, int idx)
       return;
     }
 
-  Elf_Data *data = elf_rawdata (elf_getscn (ebl->elf, idx), NULL);
+  __BLOCK Elf_Data *data = elf_rawdata (elf_getscn (ebl->elf, idx), NULL);
   if (data == NULL || data->d_size == 0 || data->d_buf == NULL)
     {
       ERROR (gettext ("section [%2d] '%s': cannot get section data\n"),
@@ -3395,12 +3396,13 @@ check_attributes (Ebl *ebl, GElf_Ehdr *ehdr, GElf_Shdr *shdr, int idx)
       return;
     }
 
-  inline size_t pos (const unsigned char *p)
+  INLINE_NESTED_FUNC (size_t, pos, (const unsigned char *),
+                      (const unsigned char *p))
   {
     return p - (const unsigned char *) data->d_buf;
-  }
+  };
 
-  const unsigned char *p = data->d_buf;
+  __BLOCK const unsigned char *p = data->d_buf;
   if (*p++ != 'A')
     {
       ERROR (gettext ("section [%2d] '%s': unrecognized attribute format\n"),
@@ -3408,10 +3410,10 @@ check_attributes (Ebl *ebl, GElf_Ehdr *ehdr, GElf_Shdr *shdr, int idx)
       return;
     }
 
-  inline size_t left (void)
+  INLINE_NESTED_FUNC (size_t, left, (void), (void))
   {
     return (const unsigned char *) data->d_buf + data->d_size - p;
-  }
+  };
 
   while (left () >= 4)
     {
diff --git a/src/ld.c b/src/ld.c
index 6e96ae2..c24f75e 100644
--- a/src/ld.c
+++ b/src/ld.c
@@ -35,6 +35,7 @@
 #include <system.h>
 #include "ld.h"
 #include "list.h"
+#include "nested_func.h"
 
 
 /* Name and version of program.  */
@@ -1078,7 +1079,7 @@ determine_output_format (void)
 	  int fd = open (runp->name, O_RDONLY);
 	  if (fd != -1)
 	    {
-	      int try (Elf *elf)
+              INLINE_RECURSIVE_NESTED_FUNC (int, try, (Elf *), (Elf *elf))
 		{
 		  int result = 0;
 
@@ -1121,7 +1122,7 @@ determine_output_format (void)
 		  elf_end (elf);
 
 		  return result;
-		}
+		};
 
 	      if (try (elf_begin (fd, ELF_C_READ_MMAP, NULL)) != 0)
 		/* Found a file.  */
diff --git a/src/readelf.c b/src/readelf.c
index a082039..bcd2366 100644
--- a/src/readelf.c
+++ b/src/readelf.c
@@ -53,6 +53,7 @@
 #include "../libdw/memory-access.h"
 
 #include "../libdw/known-dwarf.h"
+#include "nested_func.h"
 
 
 /* Name and version of program.  */
@@ -308,7 +309,8 @@ static error_t
 parse_opt (int key, char *arg,
 	   struct argp_state *state __attribute__ ((unused)))
 {
-  void add_dump_section (const char *name, bool implicit)
+  NESTED_FUNC (void, add_dump_section,
+               (const char *, bool), (const char *name, bool implicit))
   {
     struct section_argument *a = xmalloc (sizeof *a);
     a->arg = name;
@@ -318,7 +320,7 @@ parse_opt (int key, char *arg,
       = key == 'x' ? &dump_data_sections_tail : &string_sections_tail;
     **tailp = a;
     *tailp = &a->next;
-  }
+  };
 
   switch (key)
     {
@@ -3318,11 +3320,11 @@ print_attributes (Ebl *ebl, const GElf_Ehdr *ehdr)
 	      elf_strptr (ebl->elf, shstrndx, shdr->sh_name),
 	      shdr->sh_size, shdr->sh_offset);
 
-      Elf_Data *data = elf_rawdata (scn, NULL);
+      __BLOCK Elf_Data *data = elf_rawdata (scn, NULL);
       if (unlikely (data == NULL || data->d_size == 0))
 	return;
 
-      const unsigned char *p = data->d_buf;
+      __BLOCK const unsigned char *p = data->d_buf;
 
       /* There is only one 'version', A.  */
       if (unlikely (*p++ != 'A'))
@@ -3330,10 +3332,10 @@ print_attributes (Ebl *ebl, const GElf_Ehdr *ehdr)
 
       fputs_unlocked (gettext ("  Owner          Size\n"), stdout);
 
-      inline size_t left (void)
+      INLINE_NESTED_FUNC (size_t, left, (void), (void))
       {
 	return (const unsigned char *) data->d_buf + data->d_size - p;
-      }
+      };
 
       /* Loop over the sections.  */
       while (left () >= 4)
@@ -4943,12 +4945,12 @@ print_cfa_program (const unsigned char *readp, const unsigned char *const endp,
 		   unsigned int version, unsigned int ptr_size,
 		   Dwfl_Module *dwflmod, Ebl *ebl, Dwarf *dbg)
 {
-  char *regnamebuf = alloca (REGNAMESZ);
-  const char *regname (unsigned int regno)
+   __BLOCK char *regnamebuf = alloca (REGNAMESZ);
+   NESTED_FUNC (const char *, regname, (unsigned int), (unsigned int regno))
   {
     register_info (ebl, regno, NULL, regnamebuf, NULL, NULL);
     return regnamebuf;
-  }
+  };
 
   puts ("\n   Program:");
   Dwarf_Word pc = vma_base;
@@ -6423,7 +6425,7 @@ print_debug_line_section (Dwfl_Module *dwflmod, Ebl *ebl, GElf_Ehdr *ehdr,
       uint_fast8_t minimum_instr_len = *linep++;
 
       /* Next the maximum operations per instruction, in version 4 format.  */
-      uint_fast8_t max_ops_per_instr = version < 4 ? 1 : *linep++;
+      const uint_fast8_t max_ops_per_instr = version < 4 ? 1 : *linep++;
 
 	/* Then the flag determining the default value of the is_stmt
 	   register.  */
@@ -6536,8 +6538,8 @@ print_debug_line_section (Dwfl_Module *dwflmod, Ebl *ebl, GElf_Ehdr *ehdr,
       ++linep;
 
       puts (gettext ("\nLine number statements:"));
-      Dwarf_Word address = 0;
-      unsigned int op_index = 0;
+      __BLOCK Dwarf_Word address = 0;
+      __BLOCK unsigned int op_index = 0;
       size_t line = 1;
       uint_fast8_t is_stmt = default_is_stmt;
 
@@ -6571,9 +6573,10 @@ print_debug_line_section (Dwfl_Module *dwflmod, Ebl *ebl, GElf_Ehdr *ehdr,
 
       /* Apply the "operation advance" from a special opcode
 	 or DW_LNS_advance_pc (as per DWARF4 6.2.5.1).  */
-      unsigned int op_addr_advance;
-      bool show_op_index;
-      inline void advance_pc (unsigned int op_advance)
+      __BLOCK unsigned int op_addr_advance;
+      __BLOCK bool show_op_index;
+      INLINE_NESTED_FUNC (void, advance_pc,
+                          (unsigned int), (unsigned int op_advance))
       {
 	op_addr_advance = minimum_instr_len * ((op_index + op_advance)
 					       / max_ops_per_instr);
@@ -6581,7 +6584,7 @@ print_debug_line_section (Dwfl_Module *dwflmod, Ebl *ebl, GElf_Ehdr *ehdr,
 	show_op_index = (op_index > 0 ||
 			 (op_index + op_advance) % max_ops_per_instr > 0);
 	op_index = (op_index + op_advance) % max_ops_per_instr;
-      }
+      };
 
       if (max_ops_per_instr == 0)
 	{
@@ -8896,7 +8899,7 @@ handle_core_registers (Ebl *ebl, Elf *core, const void *desc,
   if (nregloc == 0)
     return 0;
 
-  ssize_t maxnreg = ebl_register_info (ebl, 0, NULL, 0, NULL, NULL, NULL, NULL);
+  __BLOCK  ssize_t maxnreg = ebl_register_info (ebl, 0, NULL, 0, NULL, NULL, NULL, NULL);
   if (maxnreg <= 0)
     {
       for (size_t i = 0; i < nregloc; ++i)
@@ -8906,7 +8909,7 @@ handle_core_registers (Ebl *ebl, Elf *core, const void *desc,
     }
 
   const int sizeof_regs = sizeof (struct register_info) * maxnreg;
-  struct register_info *regs = alloca (sizeof_regs);
+  __BLOCK struct register_info *regs = alloca (sizeof_regs);
   memset (regs, 0, sizeof_regs);
 
   /* Sort to collect the sets together.  */
@@ -8928,14 +8931,17 @@ handle_core_registers (Ebl *ebl, Elf *core, const void *desc,
   qsort (regs, maxreg + 1, sizeof regs[0], &compare_registers);
 
   /* Collect the unique sets and sort them.  */
-  inline bool same_set (const struct register_info *a,
-			const struct register_info *b)
+  INLINE_NESTED_FUNC (bool, same_set,
+                      (const struct register_info *,
+                       const struct register_info *),
+                      (const struct register_info *a,
+                       const struct register_info *b))
   {
     return (a < &regs[maxnreg] && a->regloc != NULL
 	    && b < &regs[maxnreg] && b->regloc != NULL
 	    && a->bits == b->bits
 	    && (a->set == b->set || !strcmp (a->set, b->set)));
-  }
+  };
   struct register_info *sets[maxreg + 1];
   sets[0] = &regs[0];
   size_t nsets = 1;
diff --git a/src/strip.c b/src/strip.c
index 5e69334..0ffad15 100644
--- a/src/strip.c
+++ b/src/strip.c
@@ -44,6 +44,8 @@
 #include <libebl.h>
 #include <system.h>
 
+#include "nested_func.h"
+
 typedef uint8_t GElf_Byte;
 
 /* Name and version of program.  */
@@ -409,16 +411,16 @@ static int
 handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 	    mode_t mode, struct timespec tvp[2])
 {
-  size_t prefix_len = prefix == NULL ? 0 : strlen (prefix);
-  size_t fname_len = strlen (fname) + 1;
-  char *fullname = alloca (prefix_len + 1 + fname_len);
-  char *cp = fullname;
-  Elf *debugelf = NULL;
+  __BLOCK size_t prefix_len = prefix == NULL ? 0 : strlen (prefix);
+  __BLOCK size_t fname_len = strlen (fname) + 1;
+  __BLOCK char *fullname = alloca (prefix_len + 1 + fname_len);
+  __BLOCK char *cp = fullname;
+  __BLOCK Elf *debugelf = NULL;
   tmp_debug_fname = NULL;
-  int result = 0;
-  size_t shdridx = 0;
-  size_t shstrndx;
-  struct shdr_info
+  __BLOCK int result = 0;
+  __BLOCK size_t shdridx = 0;
+  __BLOCK size_t shstrndx;
+  __BLOCK struct shdr_info
   {
     Elf_Scn *scn;
     GElf_Shdr shdr;
@@ -435,19 +437,19 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
     struct Ebl_Strent *se;
     Elf32_Word *newsymidx;
   } *shdr_info = NULL;
-  Elf_Scn *scn;
-  size_t cnt;
-  size_t idx;
-  bool changes;
-  GElf_Ehdr newehdr_mem;
-  GElf_Ehdr *newehdr;
-  GElf_Ehdr debugehdr_mem;
-  GElf_Ehdr *debugehdr;
-  struct Ebl_Strtab *shst = NULL;
-  Elf_Data debuglink_crc_data;
-  bool any_symtab_changes = false;
-  Elf_Data *shstrtab_data = NULL;
-  void *debuglink_buf = NULL;
+  __BLOCK Elf_Scn *scn;
+  __BLOCK size_t cnt;
+  __BLOCK size_t idx;
+  __BLOCK bool changes;
+  __BLOCK GElf_Ehdr newehdr_mem;
+  __BLOCK GElf_Ehdr *newehdr;
+  __BLOCK GElf_Ehdr debugehdr_mem;
+  __BLOCK GElf_Ehdr *debugehdr;
+  __BLOCK struct Ebl_Strtab *shst = NULL;
+  __BLOCK Elf_Data debuglink_crc_data;
+  __BLOCK bool any_symtab_changes = false;
+  __BLOCK Elf_Data *shstrtab_data = NULL;
+  __BLOCK void *debuglink_buf = NULL;
 
   /* Create the full name of the file.  */
   if (prefix != NULL)
@@ -474,7 +476,7 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
      option or resolving all relocations between debug sections with
      the --reloc-debug-sections option are currently the only reasons
      we need EBL so don't open the backend unless necessary.  */
-  Ebl *ebl = NULL;
+  __BLOCK Ebl *ebl = NULL;
   if (remove_debug || reloc_debug)
     {
       ebl = ebl_openbackend (elf);
@@ -929,7 +931,7 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 		 file's .data pointer.  Below, we'll copy the section
 		 contents.  */
 
-	      inline void check_preserved (size_t i)
+	      INLINE_NESTED_FUNC (void, check_preserved, (size_t), (size_t i))
 	      {
 		if (i != 0 && i < shnum + 2 && shdr_info[i].idx != 0
 		    && shdr_info[i].debug_data == NULL)
@@ -942,7 +944,7 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 		    shdr_info[i].debug_data = shdr_info[i].data;
 		    changes |= i < cnt;
 		  }
-	      }
+	      };
 
 	      check_preserved (shdr_info[cnt].shdr.sh_link);
 	      if (SH_INFO_LINK_P (&shdr_info[cnt].shdr))
@@ -1433,7 +1435,7 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 	/* Update section headers when the data size has changed.
 	   We also update the SHT_NOBITS section in the debug
 	   file so that the section headers match in sh_size.  */
-	inline void update_section_size (const Elf_Data *newdata)
+	INLINE_NESTED_FUNC (void, update_section_size, (const Elf_Data *), (const Elf_Data *newdata))
 	{
 	  GElf_Shdr shdr_mem;
 	  GElf_Shdr *shdr = gelf_getshdr (scn, &shdr_mem);
@@ -1448,7 +1450,7 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 		INTERNAL_ERROR (fname);
 	      debugdata->d_size = newdata->d_size;
 	    }
-	}
+	};
 
 	if (shdr_info[cnt].idx == 0 && debug_fname == NULL)
 	  /* Ignore sections which are discarded.  When we are saving a
@@ -1459,9 +1461,8 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 	const Elf32_Word symtabidx = shdr_info[cnt].old_sh_link;
 	elf_assert (symtabidx < shnum + 2);
 	const Elf32_Word *const newsymidx = shdr_info[symtabidx].newsymidx;
-	switch (shdr_info[cnt].shdr.sh_type)
-	  {
-	    inline bool no_symtab_updates (void)
+
+	    INLINE_NESTED_FUNC (bool, no_symtab_updates, (void), (void))
 	    {
 	      /* If the symbol table hasn't changed, do not do anything.  */
 	      if (shdr_info[symtabidx].newsymidx == NULL)
@@ -1472,8 +1473,10 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 		 is discarded, don't adjust anything.  */
 	      return (shdr_info[cnt].idx == 0
 		      && shdr_info[symtabidx].debug_data != NULL);
-	    }
+	    };
 
+	switch (shdr_info[cnt].shdr.sh_type)
+	  {
 	  case SHT_REL:
 	  case SHT_RELA:
 	    if (no_symtab_updates ())
@@ -1790,7 +1793,7 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 	      /* Pick up the symbol table and shndx table to
 		 resolve relocation symbol indexes.  */
 	      Elf64_Word symt = shdr->sh_link;
-	      Elf_Data *symdata, *xndxdata;
+	      __BLOCK Elf_Data *symdata, *xndxdata;
 	      elf_assert (symt < shnum + 2);
 	      elf_assert (shdr_info[symt].symtab_idx < shnum + 2);
 	      symdata = (shdr_info[symt].debug_data
@@ -1800,8 +1803,9 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 
 	      /* Apply one relocation.  Returns true when trivial
 		 relocation actually done.  */
-	      bool relocate (GElf_Addr offset, const GElf_Sxword addend,
-			     bool is_rela, int rtype, int symndx)
+	      NESTED_FUNC (bool, relocate,
+                          (GElf_Addr, const GElf_Sxword, bool, int, int),
+                          (GElf_Addr offset, const GElf_Sxword addend, bool is_rela, int rtype, int symndx))
 	      {
 		/* R_*_NONE relocs can always just be removed.  */
 		if (rtype == 0)
@@ -1924,7 +1928,7 @@ handle_elf (int fd, Elf *elf, const char *prefix, const char *fname,
 		    return true;
 		  }
 		return false;
-	      }
+	      };
 
 	      if (shdr->sh_entsize == 0)
 		INTERNAL_ERROR (fname);
diff --git a/src/unstrip.c b/src/unstrip.c
index a42aad6..4fca18b 100644
--- a/src/unstrip.c
+++ b/src/unstrip.c
@@ -49,6 +49,7 @@
 #include <libebl.h>
 #include <libdwfl.h>
 #include "system.h"
+#include "nested_func.h"
 
 #ifndef _
 # define _(str) gettext (str)
@@ -399,14 +400,14 @@ static void
 adjust_relocs (Elf_Scn *outscn, Elf_Scn *inscn, const GElf_Shdr *shdr,
 	       size_t map[], const GElf_Shdr *symshdr)
 {
-  Elf_Data *data = elf_getdata (outscn, NULL);
+  __BLOCK Elf_Data *data = elf_getdata (outscn, NULL);
 
-  inline void adjust_reloc (GElf_Xword *info)
+  INLINE_NESTED_FUNC (void, adjust_reloc, (GElf_Xword *), (GElf_Xword *info))
     {
       size_t ndx = GELF_R_SYM (*info);
       if (ndx != STN_UNDEF)
 	*info = GELF_R_INFO (map[ndx - 1], GELF_R_TYPE (*info));
-    }
+    };
 
   switch (shdr->sh_type)
     {
@@ -1063,8 +1064,10 @@ find_alloc_sections_prelink (Elf *debug, Elf_Data *debug_shstrtab,
 	     sizeof undo_sections[0], compare_sections_nonrel);
     }
 
-  bool fail = false;
-  inline void check_match (bool match, Elf_Scn *scn, const char *name)
+  __BLOCK bool fail = false;
+  INLINE_NESTED_FUNC (void, check_match,
+                      (bool, Elf_Scn *, const char *),
+                      (bool match, Elf_Scn *scn, const char *name))
     {
       if (!match)
 	{
@@ -1072,7 +1075,7 @@ find_alloc_sections_prelink (Elf *debug, Elf_Data *debug_shstrtab,
 	  error (0, 0, _("cannot find matching section for [%zu] '%s'"),
 		 elf_ndxscn (scn), name);
 	}
-    }
+    };
 
   Elf_Scn *scn = NULL;
   while ((scn = elf_nextscn (debug, scn)) != NULL)
@@ -1264,9 +1267,9 @@ copy_elided_sections (Elf *unstripped, Elf *stripped,
 more sections in stripped file than debug file -- arguments reversed?"));
 
   /* Cache the stripped file's section details.  */
-  struct section *sections =
+  __BLOCK struct section *sections =
       alloca (sizeof (struct section) * (stripped_shnum - 1));
-  Elf_Scn *scn = NULL;
+  __BLOCK Elf_Scn *scn = NULL;
   while ((scn = elf_nextscn (stripped, scn)) != NULL)
     {
       size_t i = elf_ndxscn (scn) - 1;
@@ -1282,13 +1285,13 @@ more sections in stripped file than debug file -- arguments reversed?"));
       sections[i].strent = NULL;
     }
 
-  const struct section *stripped_symtab = NULL;
+  __BLOCK const struct section *stripped_symtab = NULL;
 
   /* Sort the sections, allocated by address and others after.  */
   qsort (sections, stripped_shnum - 1, sizeof sections[0],
 	 stripped_ehdr->e_type == ET_REL
 	 ? compare_sections_rel : compare_sections_nonrel);
-  size_t nalloc = stripped_shnum - 1;
+  __BLOCK size_t nalloc = stripped_shnum - 1;
   while (nalloc > 0 && !(sections[nalloc - 1].shdr.sh_flags & SHF_ALLOC))
     {
       --nalloc;
@@ -1297,8 +1300,9 @@ more sections in stripped file than debug file -- arguments reversed?"));
     }
 
   /* Locate a matching unallocated section in SECTIONS.  */
-  inline struct section *find_unalloc_section (const GElf_Shdr *shdr,
-					       const char *name)
+  INLINE_NESTED_FUNC (struct section *, find_unalloc_section,
+                      (const GElf_Shdr *, const char *),
+                      (const GElf_Shdr *shdr, const char *name))
     {
       size_t l = nalloc, u = stripped_shnum - 1;
       while (l < u)
@@ -1315,7 +1319,7 @@ more sections in stripped file than debug file -- arguments reversed?"));
 	    return sec;
 	}
       return NULL;
-    }
+    };
 
   Elf_Data *shstrtab = elf_getdata (elf_getscn (unstripped,
 						unstripped_shstrndx), NULL);
@@ -1989,13 +1993,13 @@ handle_explicit_files (const char *output_file, bool create_dirs, bool force,
 
   /* Warn, and exit if not forced to continue, if some ELF header
      sanity check for the stripped and unstripped files failed.  */
-  void warn (const char *msg)
+  NESTED_FUNC (void, warn, (const char *), (const char *msg))
   {
     error (force ? 0 : EXIT_FAILURE, 0, "%s'%s' and '%s' %s%s.",
 	   force ? _("WARNING: ") : "",
 	   stripped_file, unstripped_file, msg,
 	   force ? "" : _(", use --force"));
-  }
+  };
 
   int stripped_fd = open_file (stripped_file, false);
   Elf *stripped = elf_begin (stripped_fd, ELF_C_READ, NULL);
@@ -2249,11 +2253,11 @@ match_module (Dwfl_Module *mod,
 static void
 handle_implicit_modules (const struct arg_info *info)
 {
-  struct match_module_info mmi = { info->args, NULL, info->match_files };
-  inline ptrdiff_t next (ptrdiff_t offset)
+  __BLOCK struct match_module_info mmi = { info->args, NULL, info->match_files };
+  INLINE_NESTED_FUNC (ptrdiff_t, next, (ptrdiff_t), (ptrdiff_t offset))
     {
       return dwfl_getmodules (info->dwfl, &match_module, &mmi, offset);
-    }
+    };
   ptrdiff_t offset = next (0);
   if (offset == 0)
     error (EXIT_FAILURE, 0, _("no matching modules found"));
-- 
2.6.0.rc0.131.gf624c3d

